SystemOrganization addCategory: #Roulette!

Object subclass: #Roulette
	instanceVariableNames: 'slots'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roulette'!

!Roulette methodsFor: 'as yet unclassified' stamp: 'hjo 6/2/2008 18:54'!
add: anObject area: aNumber

	self slots add: (RouletteSlot area: aNumber subject: anObject)! !

!Roulette methodsFor: 'as yet unclassified' stamp: 'hjo 6/2/2008 19:05'!
areaSum

	^(slots collect: [:slot|slot area]) sum! !

!Roulette methodsFor: 'as yet unclassified' stamp: 'hjo 6/2/2008 19:05'!
areaSum: aNumber

	|scale|
	scale :=  aNumber / self areaSum.
	slots do: [:slot| slot area: slot area * scale]! !

!Roulette methodsFor: 'as yet unclassified' stamp: 'hjo 6/2/2008 19:05'!
ball: aNumber

	^(self ballAndLocalBall: aNumber) first! !

!Roulette methodsFor: 'as yet unclassified' stamp: 'hjo 6/2/2008 19:04'!
ballAndLocalBall: aNumber

	|searchKey|
	searchKey := aNumber.
	slots do: [:slot| searchKey <= slot area ifTrue: [^Array with: slot subject with: searchKey] ifFalse: [searchKey := searchKey - slot area]].
	self error: 'Wide off the board'! !

!Roulette methodsFor: 'as yet unclassified' stamp: 'hjo 6/2/2008 19:05'!
localBall: aNumber

	^(self ballAndLocalBall: aNumber) second! !

!Roulette methodsFor: 'as yet unclassified' stamp: 'hjo 6/2/2008 19:06'!
remove: anObject

	slots remove: (slots detect: [:sl| sl subject == anObject])! !

!Roulette methodsFor: 'accessing' stamp: 'hjo 6/2/2008 19:02'!
slots
	
	slots isNil ifTrue: [ 
		self slots: (SortedCollection sortBlock: #area descendingSortBlock)
	].
	^slots! !

!Roulette methodsFor: 'accessing' stamp: 'hjo 6/2/2008 19:03'!
slots: aSortedCollection
	
	slots := aSortedCollection! !

Object subclass: #RouletteSlot
	instanceVariableNames: 'area subject'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roulette'!

!RouletteSlot classSide methodsFor: 'as yet unclassified' stamp: 'hjo 6/2/2008 18:58'!
area: aNumber subject: anObject

	^self new area: aNumber; subject: anObject! !

!RouletteSlot methodsFor: 'accessing' stamp: 'hjo 6/2/2008 19:03'!
area
	^area! !

!RouletteSlot methodsFor: 'accessing' stamp: 'hjo 6/2/2008 18:59'!
area: aNumber

	area := aNumber! !

!RouletteSlot methodsFor: 'accessing' stamp: 'hjo 6/2/2008 19:04'!
subject

	^subject! !

!RouletteSlot methodsFor: 'accessing' stamp: 'hjo 6/2/2008 18:59'!
subject: anObject

	subject := anObject! !
